=== modified file 'Makefile'
--- Makefile	2012-06-01 18:39:03 +0000
+++ Makefile	2012-05-24 18:10:10 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.5
+version=1.5.4
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== modified file 'NEWS'
--- NEWS	2012-06-01 18:39:03 +0000
+++ NEWS	2012-05-20 13:52:09 +0000
@@ -1,10 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.5.5 (2012-06-01)
-* Server
-** Server takes new --socket option
-
 Version 1.5.4 (2012-05-20)
 * Server
 ** Bug fix: Regression fix: Make non-zero approval timeout values work.

=== modified file 'TODO'
--- TODO	2012-05-26 22:21:17 +0000
+++ TODO	2012-05-12 19:29:05 +0000
@@ -48,6 +48,8 @@
    SetLogLevel D-Bus call
 ** TODO Implement --foreground						  :BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Implement --socket
+   [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given

=== modified file 'common.ent'
--- common.ent	2012-06-01 18:39:03 +0000
+++ common.ent	2012-05-20 13:52:09 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.5">
+<!ENTITY version "1.5.4">

=== modified file 'debian/changelog'
--- debian/changelog	2012-06-01 18:39:03 +0000
+++ debian/changelog	2012-05-20 13:52:09 +0000
@@ -1,12 +1,3 @@
-mandos (1.5.5-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright (Format): Updated to
-    "http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/".
-  * debian/control (Build-Depends): Removed "man, locales-all".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 01 Jun 2012 20:30:41 +0200
-
 mandos (1.5.4-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/copyright'
--- debian/copyright	2012-06-01 21:48:12 +0000
+++ debian/copyright	2012-05-24 18:10:10 +0000
@@ -5,7 +5,7 @@
 
 Files: *
 Copyright: Copyright © 2008-2012 Teddy Hogeborn
-	   Copyright © 2008-2012 Björn Påhlsson
+Copyright: Copyright © 2008-2012 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.README.Debian	2012-01-01 04:52:07 +0000
@@ -56,7 +56,7 @@
   the interface (see mandos-client(8mandos)) and placing it in
   "/etc/mandos/network-hooks.d", from where it will be copied into the
   initial RAM disk.  Example network hook scripts can be found in
-  "/usr/share/doc/mandos-client/examples/network-hooks.d".
+  "/usr/share/doc/mandos-client/network-hooks.d".
 
 * User-Supplied Plugins
   
@@ -90,4 +90,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Fri,  1 Jun 2012 23:46:13 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Nov 2011 23:07:22 +0100

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.docs	2011-11-27 02:32:20 +0000
@@ -1,3 +1,4 @@
 NEWS
 README
 TODO
+network-hooks.d

=== removed file 'debian/mandos-client.examples'
--- debian/mandos-client.examples	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.examples	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-network-hooks.d

=== modified file 'debian/rules'
--- debian/rules	2012-06-01 21:48:12 +0000
+++ debian/rules	2012-02-21 21:20:12 +0000
@@ -79,7 +79,6 @@
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
-	dh_installexamples
 	dh_link
 	dh_strip
 	dh_compress
@@ -87,7 +86,7 @@
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/mandos/plugins.d \
-		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
+		--exclude usr/share/doc/mandos-client/network-hooks.d
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

=== modified file 'init.d-mandos'
--- init.d-mandos	2012-06-01 21:48:12 +0000
+++ init.d-mandos	2011-10-05 16:00:56 +0000
@@ -149,9 +149,6 @@
 		;;
 	esac
 	;;
-  status)
-	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE"
-	;;
   *)
 	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
 	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2

=== modified file 'mandos'
--- mandos	2012-06-01 18:39:03 +0000
+++ mandos	2012-05-24 18:10:10 +0000
@@ -88,7 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.5"
+version = "1.5.4"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -1899,42 +1899,12 @@
         use_ipv6:       Boolean; to use IPv6 or not
     """
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, socketfd=None):
-        """If socketfd is set, use that file descriptor instead of
-        creating a new one with socket.socket().
-        """
+                 interface=None, use_ipv6=True):
         self.interface = interface
         if use_ipv6:
             self.address_family = socket.AF_INET6
-        if socketfd is not None:
-            # Save the file descriptor
-            self.socketfd = socketfd
-            # Save the original socket.socket() function
-            self.socket_socket = socket.socket
-            # To implement --socket, we monkey patch socket.socket.
-            # 
-            # (When socketserver.TCPServer is a new-style class, we
-            # could make self.socket into a property instead of monkey
-            # patching socket.socket.)
-            # 
-            # Create a one-time-only replacement for socket.socket()
-            @functools.wraps(socket.socket)
-            def socket_wrapper(*args, **kwargs):
-                # Restore original function so subsequent calls are
-                # not affected.
-                socket.socket = self.socket_socket
-                del self.socket_socket
-                # This time only, return a new socket object from the
-                # saved file descriptor.
-                return socket.fromfd(self.socketfd, *args, **kwargs)
-            # Replace socket.socket() function with wrapper
-            socket.socket = socket_wrapper
-        # The socketserver.TCPServer.__init__ will call
-        # socket.socket(), which might be our replacement,
-        # socket_wrapper(), if socketfd was set.
         socketserver.TCPServer.__init__(self, server_address,
                                         RequestHandlerClass)
-    
     def server_bind(self):
         """This overrides the normal server_bind() function
         to bind to an interface if one was specified, and also NOT to
@@ -1998,7 +1968,7 @@
     """
     def __init__(self, server_address, RequestHandlerClass,
                  interface=None, use_ipv6=True, clients=None,
-                 gnutls_priority=None, use_dbus=True, socketfd=None):
+                 gnutls_priority=None, use_dbus=True):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
@@ -2008,8 +1978,7 @@
         IPv6_TCPServer.__init__(self, server_address,
                                 RequestHandlerClass,
                                 interface = interface,
-                                use_ipv6 = use_ipv6,
-                                socketfd = socketfd)
+                                use_ipv6 = use_ipv6)
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
@@ -2196,9 +2165,6 @@
     parser.add_argument("--no-restore", action="store_false",
                         dest="restore", help="Do not restore stored"
                         " state")
-    parser.add_argument("--socket", type=int,
-                        help="Specify a file descriptor to a network"
-                        " socket to use instead of creating one")
     parser.add_argument("--statedir", metavar="DIR",
                         help="Directory to save/restore state in")
     
@@ -2221,7 +2187,6 @@
                         "use_ipv6": "True",
                         "debuglevel": "",
                         "restore": "True",
-                        "socket": "",
                         "statedir": "/var/lib/mandos"
                         }
     
@@ -2239,15 +2204,6 @@
     if server_settings["port"]:
         server_settings["port"] = server_config.getint("DEFAULT",
                                                        "port")
-    if server_settings["socket"]:
-        server_settings["socket"] = server_config.getint("DEFAULT",
-                                                         "socket")
-        # Later, stdin will, and stdout and stderr might, be dup'ed
-        # over with an opened os.devnull.  But we don't want this to
-        # happen with a supplied network socket.
-        if 0 <= server_settings["socket"] <= 2:
-            server_settings["socket"] = os.dup(server_settings
-                                               ["socket"])
     del server_config
     
     # Override the settings from the config file with command line
@@ -2255,7 +2211,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket"):
+                   "statedir"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2309,9 +2265,7 @@
                               use_ipv6=use_ipv6,
                               gnutls_priority=
                               server_settings["priority"],
-                              use_dbus=use_dbus,
-                              socketfd=(server_settings["socket"]
-                                        or None))
+                              use_dbus=use_dbus)
     if not debug:
         pidfilename = "/var/run/mandos.pid"
         try:
@@ -2362,8 +2316,6 @@
         # Close all input and output, do double fork, etc.
         daemon()
     
-    # multiprocessing will use threads, so before we use gobject we
-    # need to inform gobject that threads will be used.
     gobject.threads_init()
     
     global main_loop

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2012-05-26 22:48:45 +0000
+++ mandos-clients.conf.xml	2012-05-12 19:29:05 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2012-05-27">
+<!ENTITY TIMESTAMP "2012-05-12">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -167,12 +167,12 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    This option overrides the default shell command that the
-	    server will use to check if the client is still up.  Any
-	    output of the command will be ignored, only the exit code
-	    is checked:  If the exit code of the command is zero, the
-	    client is considered up.  The command will be run using
-	    <quote><command><filename>/bin/sh</filename>
+	    This option allows you to override the default shell
+	    command that the server will use to check if the client is
+	    still up.  Any output of the command will be ignored, only
+	    the exit code is checked:  If the exit code of the command
+	    is zero, the client is considered up.  The command will be
+	    run using <quote><command><filename>/bin/sh</filename>
 	    <option>-c</option></command></quote>, so
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
@@ -512,8 +512,6 @@
       <citerefentry><refentrytitle>mandos.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>fping</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>
     </para>
   </refsect1>

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-06-01 18:39:03 +0000
+++ mandos-ctl	2012-05-20 13:52:09 +0000
@@ -63,7 +63,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.5"
+version = "1.5.4"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-06-01 18:39:03 +0000
+++ mandos-keygen	2012-05-20 13:52:09 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.5"
+VERSION="1.5.4"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-06-01 18:39:03 +0000
+++ mandos-monitor	2012-05-20 13:52:09 +0000
@@ -55,7 +55,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.5"
+version = "1.5.4"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2012-05-26 22:21:17 +0000
+++ mandos-options.xml	2012-01-01 04:02:00 +0000
@@ -97,10 +97,4 @@
     class="directory">/var/lib/mandos</filename></quote>.
   </para>
   
-  <para id="socket">
-    If this option is used, the server will not create a new network
-    socket, but will instead use the supplied file descriptor.  By
-    default, the server will create a new network socket.
-  </para>
-  
 </section>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2012-05-26 22:21:17 +0000
+++ mandos.conf.xml	2011-12-31 23:05:34 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -174,14 +174,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>socket<literal> = </literal><replaceable
-	>NUMBER</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="socket"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-06-01 18:39:03 +0000
+++ mandos.lsm	2012-05-20 13:52:09 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.5
-Entered-date:	2012-06-01
+Version:	1.5.4
+Entered-date:	2012-05-20
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      148K mandos_1.5.5.orig.tar.gz
+	      148K mandos_1.5.4.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		148K mandos_1.5.5.orig.tar.gz
+		148K mandos_1.5.4.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-05-26 22:21:17 +0000
+++ mandos.xml	2012-01-15 21:01:13 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-01-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -100,9 +100,6 @@
       <sbr/>
       <arg><option>--statedir
       <replaceable>DIRECTORY</replaceable></option></arg>
-      <sbr/>
-      <arg><option>--socket
-      <replaceable>FD</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -302,15 +299,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--socket
-	<replaceable>FD</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="socket"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2012-06-13 22:06:57 +0000
+++ network-hooks.d/bridge	2012-04-24 06:55:34 +0000
@@ -33,11 +33,8 @@
     exit
 fi
 
-if [ -n "$DEVICE" ]; then
-    case "$DEVICE" in
-	*,"$BRIDGE"|*,"$BRIDGE",*|"$BRIDGE",*|"$BRIDGE") :;;
-	*) exit;;
-    esac
+if [ -n "$DEVICE" -a "$DEVICE" != "$BRIDGE" ]; then
+    exit
 fi
 
 brctl="/sbin/brctl"

=== modified file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2012-06-13 22:06:57 +0000
+++ network-hooks.d/openvpn	2012-04-24 06:55:34 +0000
@@ -31,11 +31,8 @@
 fi
 
 # Exit if DEVICE is set and it doesn't match the VPN interface
-if [ -n "$DEVICE" ]; then
-    case "$DEVICE" in
-	*,"$VPNDEVICE"*|"$VPNDEVICE"*) :;;
-	*) exit;;
-    esac
+if [ -n "$DEVICE" -a "$DEVICE" = "${DEVICE#$VPNDEVICE}" ]; then
+    exit
 fi
 
 openvpn=/usr/sbin/openvpn

=== modified file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2012-06-13 22:06:57 +0000
+++ network-hooks.d/wireless	2012-05-25 15:59:39 +0000
@@ -43,11 +43,9 @@
 	for KEY in $ifkeys; do
 	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
 	    INTERFACE=`addrtoif "$ADDRESS"`
-	    
-	    case "$DEVICE" in
-		*,"$INTERFACE"|*,"$INTERFACE",*|"$INTERFACE",*|"$INTERFACE")
-		    break 2;;
-	    esac
+	    if [ "$INTERFACE" = "$DEVICE" ]; then
+		break 2
+	    fi
 	done
 	exit
     done
@@ -123,7 +121,7 @@
 	ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
 	if [ -n "$ROUTES" ]; then
 	    for route in $ROUTES; do
-		"$ip" route add "$route" dev "$INTERFACE"
+		"$ip" route add "$route" dev "$BRIDGE"
 	    done
 	fi
     done

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2012-06-13 22:06:57 +0000
+++ plugins.d/mandos-client.c	2012-05-24 18:45:45 +0000
@@ -88,10 +88,6 @@
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), WTERMSIG() */
 #include <grp.h>		/* setgroups() */
-#include <argz.h>		/* argz_add_sep(), argz_next(),
-				   argz_delete(), argz_append(),
-				   argz_stringify(), argz_add(),
-				   argz_count() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -139,8 +135,6 @@
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -1125,22 +1119,17 @@
 
 bool get_flags(const char *ifname, struct ifreq *ifr){
   int ret;
-  error_t ret_errno;
   
   int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
   if(s < 0){
-    ret_errno = errno;
     perror_plus("socket");
-    errno = ret_errno;
     return false;
   }
   strcpy(ifr->ifr_name, ifname);
   ret = ioctl(s, SIOCGIFFLAGS, ifr);
   if(ret == -1){
     if(debug){
-      ret_errno = errno;
       perror_plus("ioctl SIOCGIFFLAGS");
-      errno = ret_errno;
     }
     return false;
   }
@@ -1215,35 +1204,46 @@
 }
 
 /* 
- * This function determines if a network interface is up.
- */
-bool interface_is_up(const char *interface){
-  struct ifreq ifr;
-  if(not get_flags(interface, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-    }
-    return false;
-  }
-  
-  return (bool)(ifr.ifr_flags & IFF_UP);
-}
-
-/* 
- * This function determines if a network interface is running
- */
-bool interface_is_running(const char *interface){
-  struct ifreq ifr;
-  if(not get_flags(interface, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-    }
-    return false;
-  }
-  
-  return (bool)(ifr.ifr_flags & IFF_RUNNING);
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device which is up.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int up_interface(const struct dirent *if_entry){
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  
+  struct ifreq ifr;
+  if(not get_flags(if_entry->d_name, &ifr)){
+    if(debug){
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  /* Reject down interfaces */
+  if(not (ifr.ifr_flags & IFF_UP)){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting down interface \"%s\"\n",
+		   if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  /* Reject non-running interfaces */
+  if(not (ifr.ifr_flags & IFF_RUNNING)){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting non-running interface \"%s\"\n",
+		   if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  if(not good_flags(if_entry->d_name, &ifr)){
+    return 0;
+  }
+  return 1;
 }
 
 int notdotentries(const struct dirent *direntry){
@@ -1390,58 +1390,6 @@
   }
 }
 
-/* Set effective uid to 0, return errno */
-error_t raise_privileges(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(seteuid(0) == -1){
-    ret_errno = errno;
-    perror_plus("seteuid");
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective and real user ID to 0.  Return errno. */
-error_t raise_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = raise_privileges();
-  if(ret_errno != 0){
-    errno = old_errno;
-    return ret_errno;
-  }
-  if(setuid(0) == -1){
-    ret_errno = errno;
-    perror_plus("seteuid");
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective user ID to unprivileged saved user ID */
-error_t lower_privileges(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(seteuid(uid) == -1){
-    ret_errno = errno;
-    perror_plus("seteuid");
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Lower privileges permanently */
-error_t lower_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(setuid(uid) == -1){
-    ret_errno = errno;
-    perror_plus("setuid");
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
 bool run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
   struct dirent **direntries;
@@ -1469,7 +1417,17 @@
       if(hook_pid == 0){
 	/* Child */
 	/* Raise privileges */
-	raise_privileges_permanently();
+	errno = 0;
+	ret = seteuid(0);
+	if(ret == -1){
+	  perror_plus("seteuid");
+	}
+	/* Raise privileges even more */
+	errno = 0;
+	ret = setuid(0);
+	if(ret == -1){
+	  perror_plus("setuid");
+	}
 	/* Set group */
 	errno = 0;
 	ret = setgid(0);
@@ -1568,196 +1526,24 @@
   return true;
 }
 
-error_t bring_up_interface(const char *const interface,
-			   const float delay){
-  int sd = -1;
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  int ret, ret_setflags;
-  struct ifreq network;
-  unsigned int if_index = if_nametoindex(interface);
-  if(if_index == 0){
-    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
-    errno = old_errno;
-    return ENXIO;
-  }
-  
-  if(quit_now){
-    errno = old_errno;
-    return EINTR;
-  }
-  
-  if(not interface_is_up(interface)){
-    if(not get_flags(interface, &network) and debug){
-      ret_errno = errno;
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-      return ret_errno;
-    }
-    network.ifr_flags |= IFF_UP;
-    
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0){
-      ret_errno = errno;
-      perror_plus("socket");
-      errno = old_errno;
-      return ret_errno;
-    }
-  
-    if(quit_now){
-      close(sd);
-      errno = old_errno;
-      return EINTR;
-    }
-    
-    if(debug){
-      fprintf_plus(stderr, "Bringing up interface \"%s\"\n",
-		   interface);
-    }
-    
-    /* Raise priviliges */
-    raise_privileges();
-    
-#ifdef __linux__
-    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-       messages about the network interface to mess up the prompt */
-    int ret_linux = klogctl(8, NULL, 5);
-    bool restore_loglevel = true;
-    if(ret_linux == -1){
-      restore_loglevel = false;
-      perror_plus("klogctl");
-    }
-#endif	/* __linux__ */
-    ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
-    ret_errno = errno;
-#ifdef __linux__
-    if(restore_loglevel){
-      ret_linux = klogctl(7, NULL, 0);
-      if(ret_linux == -1){
-	perror_plus("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    
-    /* Lower privileges */
-    lower_privileges();
-    
-    /* Close the socket */
-    ret = (int)TEMP_FAILURE_RETRY(close(sd));
-    if(ret == -1){
-      perror_plus("close");
-    }
-    
-    if(ret_setflags == -1){
-      errno = ret_errno;
-      perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
-      errno = old_errno;
-      return ret_errno;
-    }
-  } else if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is already up; good\n",
-		 interface);
-  }
-  
-  /* Sleep checking until interface is running.
-     Check every 0.25s, up to total time of delay */
-  for(int i=0; i < delay * 4; i++){
-    if(interface_is_running(interface)){
-      break;
-    }
-    struct timespec sleeptime = { .tv_nsec = 250000000 };
-    ret = nanosleep(&sleeptime, NULL);
-    if(ret == -1 and errno != EINTR){
-      perror_plus("nanosleep");
-    }
-  }
-  
-  errno = old_errno;
-  return 0;
-}
-
-error_t take_down_interface(const char *const interface){
-  int sd = -1;
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  int ret, ret_setflags;
-  struct ifreq network;
-  unsigned int if_index = if_nametoindex(interface);
-  if(if_index == 0){
-    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
-    errno = old_errno;
-    return ENXIO;
-  }
-  if(interface_is_up(interface)){
-    if(not get_flags(interface, &network) and debug){
-      ret_errno = errno;
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-      return ret_errno;
-    }
-    network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
-    
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0){
-      ret_errno = errno;
-      perror_plus("socket");
-      errno = old_errno;
-      return ret_errno;
-    }
-    
-    if(debug){
-      fprintf_plus(stderr, "Taking down interface \"%s\"\n",
-		   interface);
-    }
-    
-    /* Raise priviliges */
-    raise_privileges();
-    
-    ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
-    ret_errno = errno;
-    
-    /* Lower privileges */
-    lower_privileges();
-    
-    /* Close the socket */
-    ret = (int)TEMP_FAILURE_RETRY(close(sd));
-    if(ret == -1){
-      perror_plus("close");
-    }
-    
-    if(ret_setflags == -1){
-      errno = ret_errno;
-      perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
-      errno = old_errno;
-      return ret_errno;
-    }
-  } else if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is already down; odd\n",
-		 interface);
-  }
-  
-  errno = old_errno;
-  return 0;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
-  error_t ret_errno;
+  int error;
   int ret;
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  char *interfaces = NULL;
-  size_t interfaces_size = 0;
-  char *interfaces_to_take_down = NULL;
-  size_t interfaces_to_take_down_size = 0;
+  const char *interface = "";
+  struct ifreq network;
+  int sd = -1;
+  bool take_down_interface = false;
+  uid_t uid;
+  gid_t gid;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
   const char *seckey = PATHDIR "/" SECKEY;
   const char *pubkey = PATHDIR "/" PUBKEY;
-  char *interfaces_hooks = NULL;
-  size_t interfaces_hooks_size = 0;
   
   bool gnutls_initialized = false;
   bool gpgme_initialized = false;
@@ -1854,11 +1640,7 @@
 	connect_to = arg;
 	break;
       case 'i':			/* --interface */
-	ret_errno = argz_add_sep(&interfaces, &interfaces_size, arg,
-				 (int)',');
-	if(ret_errno != 0){
-	  argp_error(state, "%s", strerror(ret_errno));
-	}
+	interface = arg;
 	break;
       case 's':			/* --seckey */
 	seckey = arg;
@@ -1942,7 +1724,11 @@
        <http://bugs.debian.org/633582> */
     
     /* Re-raise priviliges */
-    if(raise_privileges() == 0){
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    } else {
       struct stat st;
       
       if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
@@ -1996,41 +1782,47 @@
     }
   }
   
-  /* Remove empty interface names */
-  {
-    char *interface = NULL;
-    while((interface = argz_next(interfaces, interfaces_size,
-				 interface))){
-      if(if_nametoindex(interface) == 0){
-	if(interface[0] != '\0' and strcmp(interface, "none") != 0){
-	  fprintf_plus(stderr, "Not using nonexisting interface"
-		       " \"%s\"\n", interface);
-	}
-	argz_delete(&interfaces, &interfaces_size, interface);
-	interface = NULL;
-      }
-    }
-  }
-  
   /* Run network hooks */
-  {
-    ret_errno = argz_append(&interfaces_hooks, &interfaces_hooks_size,
-			    interfaces, interfaces_size);
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("argz_append");
-      goto end;
-    }
-    argz_stringify(interfaces_hooks, interfaces_hooks_size, (int)',');
-    if(not run_network_hooks("start", interfaces_hooks, delay)){
-      goto end;
-    }
+  if(not run_network_hooks("start", interface, delay)){
+    goto end;
   }
   
   if(not debug){
     avahi_set_log_function(empty_log);
   }
   
+  if(interface[0] == '\0'){
+    struct dirent **direntries;
+    /* First look for interfaces that are up */
+    ret = scandir(sys_class_net, &direntries, up_interface,
+		  alphasort);
+    if(ret == 0){
+      /* No up interfaces, look for any good interfaces */
+      free(direntries);
+      ret = scandir(sys_class_net, &direntries, good_interface,
+		    alphasort);
+    }
+    if(ret >= 1){
+      /* Pick the first interface returned */
+      interface = strdup(direntries[0]->d_name);
+      if(debug){
+	fprintf_plus(stderr, "Using interface \"%s\"\n", interface);
+      }
+      if(interface == NULL){
+	perror_plus("malloc");
+	free(direntries);
+	exitcode = EXIT_FAILURE;
+	goto end;
+      }
+      free(direntries);
+    } else {
+      free(direntries);
+      fprintf_plus(stderr, "Could not find a network interface\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+  }
+  
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
   /* Initialize the pseudo-RNG for Avahi */
@@ -2106,68 +1898,140 @@
     }
   }
   
-  /* If no interfaces were specified, make a list */
-  if(interfaces == NULL){
-    struct dirent **direntries;
-    /* Look for any good interfaces */
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Add all found interfaces to interfaces list */
-      for(int i = 0; i < ret; ++i){
-	ret_errno = argz_add(&interfaces, &interfaces_size,
-			     direntries[i]->d_name);
-	if(ret_errno != 0){
-	  perror_plus("argz_add");
-	  continue;
-	}
-	if(debug){
-	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
-		       direntries[i]->d_name);
-	}
-      }
-      free(direntries);
-    } else {
-      free(direntries);
-      fprintf_plus(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
-  
-  /* If we only got one interface, explicitly use only that one */
-  if(argz_count(interfaces, interfaces_size) == 1){
-    if(debug){
-      fprintf_plus(stderr, "Using only interface \"%s\"\n",
-		   interfaces);
-    }
-    if_index = (AvahiIfIndex)if_nametoindex(interfaces);
-  }
-  
-  /* Bring up interfaces which are down */
-  if(not (argz_count(interfaces, interfaces_size) == 1
-	  and strcmp(interfaces, "none") == 0)){
-    char *interface = NULL;
-    while((interface = argz_next(interfaces, interfaces_size,
-				 interface))){
-      bool interface_was_up = interface_is_up(interface);
-      ret = bring_up_interface(interface, delay);
-      if(not interface_was_up){
-	if(ret != 0){
-	  errno = ret;
-	  perror_plus("Failed to bring up interface");
-	} else {
-	  ret_errno = argz_add(&interfaces_to_take_down,
-			       &interfaces_to_take_down_size,
-			       interface);
-	}
-      }
-    }
-    free(interfaces);
-    interfaces = NULL;
-    interfaces_size = 0;
-    if(debug and (interfaces_to_take_down == NULL)){
-      fprintf_plus(stderr, "No interfaces were brought up\n");
+  /* If the interface is down, bring it up */
+  if(strcmp(interface, "none") != 0){
+    if_index = (AvahiIfIndex) if_nametoindex(interface);
+    if(if_index == 0){
+      fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+      exitcode = EX_UNAVAILABLE;
+      goto end;
+    }
+    
+    if(quit_now){
+      goto end;
+    }
+    
+    /* Re-raise priviliges */
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+    
+#ifdef __linux__
+    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+       messages about the network interface to mess up the prompt */
+    ret = klogctl(8, NULL, 5);
+    bool restore_loglevel = true;
+    if(ret == -1){
+      restore_loglevel = false;
+      perror_plus("klogctl");
+    }
+#endif	/* __linux__ */
+    
+    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd < 0){
+      perror_plus("socket");
+      exitcode = EX_OSERR;
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      /* Lower privileges */
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+      goto end;
+    }
+    strcpy(network.ifr_name, interface);
+    ret = ioctl(sd, SIOCGIFFLAGS, &network);
+    if(ret == -1){
+      perror_plus("ioctl SIOCGIFFLAGS");
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      exitcode = EX_OSERR;
+      /* Lower privileges */
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+      goto end;
+    }
+    if((network.ifr_flags & IFF_UP) == 0){
+      network.ifr_flags |= IFF_UP;
+      take_down_interface = true;
+      ret = ioctl(sd, SIOCSIFFLAGS, &network);
+      if(ret == -1){
+	take_down_interface = false;
+	perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
+	exitcode = EX_OSERR;
+#ifdef __linux__
+	if(restore_loglevel){
+	  ret = klogctl(7, NULL, 0);
+	  if(ret == -1){
+	    perror_plus("klogctl");
+	  }
+	}
+#endif	/* __linux__ */
+	/* Lower privileges */
+	errno = 0;
+	ret = seteuid(uid);
+	if(ret == -1){
+	  perror_plus("seteuid");
+	}
+	goto end;
+      }
+    }
+    /* Sleep checking until interface is running.
+       Check every 0.25s, up to total time of delay */
+    for(int i=0; i < delay * 4; i++){
+      ret = ioctl(sd, SIOCGIFFLAGS, &network);
+      if(ret == -1){
+	perror_plus("ioctl SIOCGIFFLAGS");
+      } else if(network.ifr_flags & IFF_RUNNING){
+	break;
+      }
+      struct timespec sleeptime = { .tv_nsec = 250000000 };
+      ret = nanosleep(&sleeptime, NULL);
+      if(ret == -1 and errno != EINTR){
+	perror_plus("nanosleep");
+      }
+    }
+    if(not take_down_interface){
+      /* We won't need the socket anymore */
+      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      if(ret == -1){
+	perror_plus("close");
+      }
+    }
+#ifdef __linux__
+    if(restore_loglevel){
+      /* Restores kernel loglevel to default */
+      ret = klogctl(7, NULL, 0);
+      if(ret == -1){
+	perror_plus("klogctl");
+      }
+    }
+#endif	/* __linux__ */
+    /* Lower privileges */
+    errno = 0;
+    /* Lower privileges */
+    ret = seteuid(uid);
+    if(ret == -1){
+      perror_plus("seteuid");
     }
   }
   
@@ -2214,7 +2078,6 @@
     /* Connect directly, do not use Zeroconf */
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
-    
     if(address == NULL){
       fprintf_plus(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
@@ -2295,7 +2158,7 @@
     /* Allocate a new server */
     mc.server = avahi_server_new(avahi_simple_poll_get
 				 (mc.simple_poll), &config, NULL,
-				 NULL, &ret_errno);
+				 NULL, &error);
     
     /* Free the Avahi configuration data */
     avahi_server_config_free(&config);
@@ -2304,7 +2167,7 @@
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
     fprintf_plus(stderr, "Failed to create Avahi server: %s\n",
-		 avahi_strerror(ret_errno));
+		 avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2378,36 +2241,41 @@
     }
   }
   
+  /* Run network hooks */
+  run_network_hooks("stop", interface, delay);
+  
   /* Re-raise priviliges */
   {
-    raise_privileges();
-    
-    /* Run network hooks */
-    run_network_hooks("stop", interfaces_hooks, delay);
-    
-    /* Take down the network interfaces which were brought up */
-    {
-      char *interface = NULL;
-      while((interface=argz_next(interfaces_to_take_down,
-				 interfaces_to_take_down_size,
-				 interface))){
-	ret_errno = take_down_interface(interface);
-	if(ret_errno != 0){
-	  errno = ret_errno;
-	  perror_plus("Failed to take down interface");
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+    
+    /* Take down the network interface */
+    if(take_down_interface and geteuid() == 0){
+      ret = ioctl(sd, SIOCGIFFLAGS, &network);
+      if(ret == -1){
+	perror_plus("ioctl SIOCGIFFLAGS");
+      } else if(network.ifr_flags & IFF_UP){
+	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
+	ret = ioctl(sd, SIOCSIFFLAGS, &network);
+	if(ret == -1){
+	  perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
 	}
       }
-      if(debug and (interfaces_to_take_down == NULL)){
-	fprintf_plus(stderr, "No interfaces needed to be taken"
-		     " down\n");
+      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      if(ret == -1){
+	perror_plus("close");
       }
     }
-    
-    lower_privileges_permanently();
-  }
-  
-  free(interfaces_to_take_down);
-  free(interfaces_hooks);
+  }
+  /* Lower privileges permanently */
+  errno = 0;
+  ret = setuid(uid);
+  if(ret == -1){
+    perror_plus("setuid");
+  }
   
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir_created){

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2012-06-13 22:06:57 +0000
+++ plugins.d/mandos-client.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2012-06-13">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -64,13 +64,11 @@
 	><replaceable>PORT</replaceable></option></arg>
       </group>
       <sbr/>
-      <group rep='repeat'>
+      <group>
 	<arg choice="plain"><option>--interface
-	<replaceable>NAME</replaceable><arg rep='repeat'
-	>,<replaceable>NAME</replaceable></arg></option></arg>
-	<arg choice="plain"><option>-i <replaceable>NAME</replaceable
-	><arg rep='repeat'>,<replaceable>NAME</replaceable></arg
-	></option></arg>
+	<replaceable>NAME</replaceable></option></arg>
+	<arg choice="plain"><option>-i
+	<replaceable>NAME</replaceable></option></arg>
       </group>
       <sbr/>
       <group>
@@ -139,10 +137,10 @@
       communicates with <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>
       to get a password.  In slightly more detail, this client program
-      brings up network interfaces, uses the interfaces’ IPv6
-      link-local addresses to get network connectivity, uses Zeroconf
-      to find servers on the local network, and communicates with
-      servers using TLS with an OpenPGP key to ensure authenticity and
+      brings up a network interface, uses the interface’s IPv6
+      link-local address to get network connectivity, uses Zeroconf to
+      find servers on the local network, and communicates with servers
+      using TLS with an OpenPGP key to ensure authenticity and
       confidentiality.  This client program keeps running, trying all
       servers on the network, until it receives a satisfactory reply
       or a TERM signal.  After all servers have been tried, all
@@ -150,21 +148,23 @@
       will wait indefinitely for new servers to appear.
     </para>
     <para>
-      The network interfaces are selected like this: If any interfaces
-      are specified using the <option>--interface</option> option,
-      those interface are used.  Otherwise,
-      <command>&COMMANDNAME;</command> will use all interfaces that
-      are not loopback interfaces, are not point-to-point interfaces,
-      are capable of broadcasting and do not have the NOARP flag (see
+      The network interface is selected like this: If an interface is
+      specified using the <option>--interface</option> option, that
+      interface is used.  Otherwise, <command>&COMMANDNAME;</command>
+      will choose any interface that is up and running and is not a
+      loopback interface, is not a point-to-point interface, is
+      capable of broadcasting and does not have the NOARP flag (see
       <citerefentry><refentrytitle>netdevice</refentrytitle>
       <manvolnum>7</manvolnum></citerefentry>).  (If the
       <option>--connect</option> option is used, point-to-point
-      interfaces and non-broadcast interfaces are accepted.)  If any
-      used interfaces are not up and running, they are first taken up
-      (and later taken down again on program exit).
+      interfaces and non-broadcast interfaces are accepted.)  If no
+      acceptable interfaces are found, re-run the check but without
+      the <quote>up and running</quote> requirement, and manually take
+      the selected interface up (and later take it down on program
+      exit).
     </para>
     <para>
-      Before network interfaces are selected, all <quote>network
+      Before a network interface is selected, all <quote>network
       hooks</quote> are run; see <xref linkend="network-hooks"/>.
     </para>
     <para>
@@ -231,10 +231,10 @@
 	<replaceable>NAME</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Comma separated list of network interfaces that will be
-	    brought up and scanned for Mandos servers to connect to.
-	    The default is the empty string, which will automatically
-	    use all appropriate interfaces.
+	    Network interface that will be brought up and scanned for
+	    Mandos servers to connect to.  The default is the empty
+	    string, which will automatically choose an appropriate
+	    interface.
 	  </para>
 	  <para>
 	    If the <option>--connect</option> option is used, this
@@ -245,12 +245,11 @@
 	    Note that since this program will normally run in the
 	    initial RAM disk environment, the interface must be an
 	    interface which exists at that stage.  Thus, the interface
-	    can normally not be a pseudo-interface such as
-	    <quote>br0</quote> or <quote>tun0</quote>; such interfaces
-	    will not exist until much later in the boot process, and
-	    can not be used by this program, unless created by a
-	    <quote>network hook</quote> — see <xref
-	    linkend="network-hooks"/>.
+	    can not be a pseudo-interface such as <quote>br0</quote>
+	    or <quote>tun0</quote>; such interfaces will not exist
+	    until much later in the boot process, and can not be used
+	    by this program, unless created by a <quote>network
+	    hook</quote> — see <xref linkend="network-hooks"/>.
 	  </para>
 	  <para>
 	    <replaceable>NAME</replaceable> can be the string
@@ -315,7 +314,7 @@
 	>SECONDS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    After bringing a network interface up, the program waits
+	    After bringing the network interface up, the program waits
 	    for the interface to arrive in a <quote>running</quote>
 	    state before proceeding.  During this time, the kernel log
 	    level will be lowered to reduce clutter on the system
@@ -548,12 +547,11 @@
 	  <term><envar>DEVICE</envar></term>
 	  <listitem>
 	    <para>
-	      The network interfaces, as specified to
+	      The network interface, as specified to
 	      <command>&COMMANDNAME;</command> by the
-	      <option>--interface</option> option, combined to one
-	      string and separated by commas.  If this is set, and
-	      does not contain the interface a hook will bring up,
-	      there is no reason for a hook to continue.
+	      <option>--interface</option> option.  If this is not the
+	      interface a hook will bring up, there is no reason for a
+	      hook to continue.
 	    </para>
 	  </listitem>
 	</varlistentry>
@@ -663,7 +661,7 @@
     <informalexample>
       <para>
 	Normal invocation needs no options, if the network interface
-	can be automatically determined:
+	is <quote>eth0</quote>:
       </para>
       <para>
 	<userinput>&COMMANDNAME;</userinput>

